window.Gleam.initSearch([{"doc":"glaml","title":"glaml","content":"# glaml\n\n[![Package Version](https://img.shields.io/hexpm/v/glaml)](https://hex.pm/packages/glaml)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/glaml/)\n\nGlaml is a simple Gleam wrapper around [yamerl](https://hex.pm/packages/yamerl) that enables your app to read YAML.\n\n```gleam\nimport glaml\n\n// ...\n\nlet assert Ok(doc) = glaml.parse_string(&quot;\ntest: 4\nthis-is-nil:\njobs:\n  - being a cat\n&quot;)\n\nglaml.sugar(doc, &quot;jobs.#0&quot;)\n// -&gt; Ok(DocNodeStr(&quot;being a cat&quot;))\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/glaml&gt;.\n\n## Instalation\n\nYou can add **glaml** to your project by simply running the command below.\n\n```sh\ngleam add glaml\n```\n\n## Development\n\n```sh\n./develop.sh # Copy Erlang headers (for lsp)\ngleam test   # Run the tests\n```\n","url":"index.html"},{"doc":"glaml","title":"DocError","content":"pub type DocError {\n  DocError(msg: String, loc: #(Int, Int))\n}\n A Document Error dispatched by yamerl.\n It contains a string - `msg` and a tuple of 2 integers - `loc`.\n \n The location is: `#(line, column)`.\n\nDocError(msg: String, loc: #(Int, Int))\n\n\nSynonyms:\nglaml.DocError\nglaml DocError","url":"glaml.html#DocError"},{"doc":"glaml","title":"DocNode","content":"pub type DocNode {\n  DocNodeNil\n  DocNodeStr(string: String)\n  DocNodeInt(int: Int)\n  DocNodeSeq(nodes: List(DocNode))\n  DocNodeMap(nodes: List(#(DocNode, DocNode)))\n}\n\nDocNodeNil\n\n\nDocNodeStr(string: String)\n\n\nDocNodeInt(int: Int)\n\n\nDocNodeSeq(nodes: List(DocNode))\n\n\nDocNodeMap(nodes: List(#(DocNode, DocNode)))\n\n\nSynonyms:\nglaml.DocNode\nglaml DocNode","url":"glaml.html#DocNode"},{"doc":"glaml","title":"Document","content":"pub type Document {\n  Document(root: DocNode)\n}\n\nDocument(root: DocNode)\n\n\nSynonyms:\nglaml.Document\nglaml Document","url":"glaml.html#Document"},{"doc":"glaml","title":"NodeGetError","content":"pub type NodeGetError {\n  NodeNotFound(which: String)\n  InvalidSugar\n}\n\nNodeNotFound(which: String)\n\n\nInvalidSugar\n\n\nSynonyms:\nglaml.NodeGetError\nglaml NodeGetError","url":"glaml.html#NodeGetError"},{"doc":"glaml","title":"PathRule","content":"pub type PathRule {\n  Seq(idx: Int)\n  Map(key: String)\n}\n\nSeq(idx: Int)\n\n\nMap(key: String)\n\n\nSynonyms:\nglaml.PathRule\nglaml PathRule","url":"glaml.html#PathRule"},{"doc":"glaml","title":"doc_node","content":"pub fn doc_node(doc: Document) -&gt; DocNode\n Returns the root node of the `Document`.\n \nSynonyms:\nglaml.doc_node\nglaml doc_node","url":"glaml.html#doc_node"},{"doc":"glaml","title":"get","content":"pub fn get(\n  from node: DocNode,\n  to path: List(PathRule),\n) -&gt; Result(DocNode, NodeGetError)\n Traverses the `DocNode` and tries to find another `DocNode` by matching the `PathRule`s.\n \nSynonyms:\nglaml.get\nglaml get","url":"glaml.html#get"},{"doc":"glaml","title":"parse_file","content":"pub fn parse_file(path: String) -&gt; Result(Document, DocError)\n Parses the YAML file at `path` and returns either `Ok(Document(...))` or `Error(DocError(...))`.\n \nSynonyms:\nglaml.parse_file\nglaml parse_file","url":"glaml.html#parse_file"},{"doc":"glaml","title":"parse_string","content":"pub fn parse_string(string: String) -&gt; Result(Document, DocError)\n Parses the YAML string and returns either `Ok(Document(...))` or `Error(DocError(...))`.\n \nSynonyms:\nglaml.parse_string\nglaml parse_string","url":"glaml.html#parse_string"},{"doc":"glaml","title":"sugar","content":"pub fn sugar(\n  from node: DocNode,\n  to path: String,\n) -&gt; Result(DocNode, NodeGetError)\n Does the same thing as `get` but instead of a list of `PathRule`s,\n you write a `String` that will get parsed into a list of `PathRule`s for you.\n \n ## Syntax\n \n \n &quot;some_key&quot; == [Map(&quot;some_key&quot;)]\n &quot;#0&quot; == [Seq(0)]\n &quot;combination.#0.of.these&quot; == [Map(&quot;combination&quot;), Seq(0), Map(&quot;of&quot;), Map(&quot;these&quot;)]\n \n // You can write as many dots as you want\n &quot;...test..#0.&quot; == [Map(&quot;test&quot;), Seq(0)]\n \n \nSynonyms:\nglaml.sugar\nglaml sugar","url":"glaml.html#sugar"},{"doc":"glaml","title":"glaml","content":"","url":"glaml.html"}]);